Platform3D
Date: 2019-10-22

org.jmol.g3d

## Class Platform3D

- java.lang.Object
- - org.jmol.g3d.Platform3D

-     class Platform3D
      extends java.lang.Object

  Specifies the API to an underlying int[] buffer of ARGB values that can be converted into an Image object and a short[] for z-buffer depth.

  Author:
    Miguel, miguel@jmol.org

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) GenericPlatform` | `apiPlatform`
    `private static boolean` | `backgroundTransparent`
    `(package private) java.lang.Object` | `bufferedImage`
    `(package private) int` | `bufferHeight`
    `(package private) int` | `bufferSize`
    `(package private) int` | `bufferSizeT`
    `(package private) int` | `bufferWidth`
    `(package private) java.lang.Object` | `graphicsForTextOrImage`
    `(package private) int` | `heightOffscreen`
    `(package private) java.lang.Object` | `offscreenImage`
    `(package private) int[]` | `pBuffer`
    `(package private) int[]` | `pBufferT`
    `(package private) int` | `widthOffscreen`
    `(package private) int` | `windowHeight`
    `(package private) int` | `windowSize`
    `(package private) int` | `windowWidth`
    `(package private) int[]` | `zBuffer`
    `(package private) int[]` | `zBufferT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Platform3D(GenericPlatform apiPlatform)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) void` | `allocateBuffers(int width, int height, boolean antialias, boolean isImageWrite)`
    `private java.lang.Object` | `allocateOffscreenImage(int width, int height)`
    `(package private) void` | `allocateTBuffers(boolean antialiasTranslucent)`
    `(package private) void` | `clearBuffer()`
    `(package private) void` | `clearScreenBuffer()`
    `(package private) void` | `clearScreenBufferThreaded()`
    `(package private) void` | `clearTBuffer()`
    `(package private) java.lang.Object` | `getGraphicsForMetrics()`
    `(package private) java.lang.Object` | `getGraphicsForTextOrImage(int width, int height)`
    `(package private) boolean` | `hasContent()`
    `(package private) void` | `notifyEndOfRendering()`
    `(package private) void` | `releaseBuffers()`
    `(package private) void` | `setBackgroundColor(int bgColor)`
    `(package private) void` | `setBackgroundTransparent(boolean tf)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### windowWidth

          int windowWidth

    - #### windowHeight

          int windowHeight

    - #### windowSize

          int windowSize

    - #### bufferWidth

          int bufferWidth

    - #### bufferHeight

          int bufferHeight

    - #### bufferSize

          int bufferSize

    - #### bufferSizeT

          int bufferSizeT

    - #### bufferedImage

          java.lang.Object bufferedImage

    - #### pBuffer

          int[] pBuffer

    - #### pBufferT

          int[] pBufferT

    - #### zBuffer

          int[] zBuffer

    - #### zBufferT

          int[] zBufferT

    - #### widthOffscreen

          int widthOffscreen

    - #### heightOffscreen

          int heightOffscreen

    - #### offscreenImage

          java.lang.Object offscreenImage

    - #### graphicsForTextOrImage

          java.lang.Object graphicsForTextOrImage

    - #### apiPlatform

          GenericPlatform apiPlatform

    - #### backgroundTransparent

          private static boolean backgroundTransparent

  - ### Constructor Detail

    - #### Platform3D

          Platform3D(GenericPlatform apiPlatform)

  - ### Method Detail

    - #### getGraphicsForMetrics

          java.lang.Object getGraphicsForMetrics()

    - #### allocateTBuffers

          void allocateTBuffers(boolean antialiasTranslucent)

    - #### allocateBuffers

          void allocateBuffers(int width,
                               int height,
                               boolean antialias,
                               boolean isImageWrite)

      Parameters:
        `width` -
        `height` -
        `antialias` -
        `isImageWrite` -

    - #### releaseBuffers

          void releaseBuffers()

    - #### hasContent

          boolean hasContent()

    - #### clearScreenBuffer

          void clearScreenBuffer()

    - #### setBackgroundColor

          void setBackgroundColor(int bgColor)

    - #### clearTBuffer

          void clearTBuffer()

    - #### clearBuffer

          final void clearBuffer()

    - #### clearScreenBufferThreaded

          final void clearScreenBufferThreaded()

    - #### notifyEndOfRendering

          void notifyEndOfRendering()

    - #### getGraphicsForTextOrImage

          java.lang.Object getGraphicsForTextOrImage(int width,
                                                     int height)

    - #### allocateOffscreenImage

          private java.lang.Object allocateOffscreenImage(int width,
                                                          int height)

    - #### setBackgroundTransparent

          void setBackgroundTransparent(boolean tf)